Codeforces Round #527 (Div. 3) F. Tree with Maximum Cost 【DFS换根 || 树形dp】

传送门:http://codeforces.com/contest/1092/problem/F

F. Tree with Maximum Cost

time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

You are given a tree consisting exactly of nn vertices. Tree is a connected undirected graph with n1n−1 edges. Each vertex vv of this tree has a value avav assigned to it.

Let dist(x,y)dist(x,y) be the distance between the vertices xx and yy. The distance between the vertices is the number of edges on the simple path between them.

Let's define the cost of the tree as the following value: firstly, let's fix some vertex of the tree. Let it be vv. Then the cost of the tree is i=1ndist(i,v)ai∑i=1ndist(i,v)⋅ai.

Your task is to calculate the maximum possible cost of the tree if you can choose vv arbitrarily.

Input

The first line contains one integer nn, the number of vertices in the tree (1n21051≤n≤2⋅105).

The second line of the input contains nn integers a1,a2,,ana1,a2,…,an (1ai21051≤ai≤2⋅105), where aiai is the value of the vertex ii.

Each of the next n1n−1 lines describes an edge of the tree. Edge ii is denoted by two integers uiui and vivi, the labels of vertices it connects (1ui,vin1≤ui,vi≤n, uiviui≠vi).

It is guaranteed that the given edges form a tree.

Output

Print one integer — the maximum possible cost of the tree if you can choose any vertex as vv.

Examples
input
Copy
8
9 4 1 7 10 1 6 5
1 2
2 3
1 4
1 5
5 6
5 7
5 8
output
Copy
121
input
Copy
1
1337
output
Copy
0
Note

Picture corresponding to the first example:

You can choose the vertex 33 as a root, then the answer will be 29+14+01+37+310+41+46+45=18+4+0+21+30+4+24+20=1212⋅9+1⋅4+0⋅1+3⋅7+3⋅10+4⋅1+4⋅6+4⋅5=18+4+0+21+30+4+24+20=121.

In the second example tree consists only of one vertex so the answer is always 00.

题意概括:

给出一棵 有 N 个结点 N-1 条边的树,每个结点的权值为 a[ i ], 每条边的边权为 1 .

每一点的贡献 = 该点的深度 * 该点的权值。

所以以不同的点作为 整棵树的根 会得到不同的树结点的贡献总和。

求最大的树结点的贡献组合。

解题思路:

一、树的换根 两次DFS

跑第一次DFS,处理出 Sum[ u ] 以 u 为根的子树的贡献总和(包括 u 结点本身),处理出以 结点1为根 的树的贡献总和 res;

第二次 DFS 换根:

假设 fa = 1, u = 5(即从根为1 转换为根为 5)

由上图可以发现 红色部分的每一个结点都会与 根:u 多连了一条边 ,即红色部分的贡献要加倍(相当于深度+1,所有红色部分结点贡献)。

而红色部分就是 以 u 为根的子树之外的结点:即 ( Sum[ fa ] - Sum[ u ] );

蓝色部分的所有结点 都会与 根 u 少连一条边,即深度-1,蓝色部分结点贡献和减半;

以 fa = 1 为根时,总贡献和为 res;

转换为以 u = 5 为根时,总贡献和为 res + ( Sum[ fa ] - Sum[ u ]) - Sum[ u ];

当 u = 5 为根之后,

Sum[ fa ] = Sum[ fa ] - Sum[ u ] (即红色部分)因为树根变了,所以原本父亲的子树不再是整棵树,而是原来 以 u 为根的子树之外的结点。

Sum[ u ] = res; u 成为整棵树的根,整棵树都是 u 的子树。

按照这种方式递归搜索更新,取最大的res;

递归返回后,还原 Sum[ fa ], Sum[ u ], res 再搜索下一个儿子结点;

AC code:

 1 #include <cstdio>
 2 #include <iostream>
 3 #include <cstring>
 4 #define FOR(x, maxx) for(x = 1; x <= maxx; x++)
 5 #define ZERO(aa, x) memset(aa, x, sizeof(aa))
 6 #define INF 0x3f3f3f3f
 7 #define LL long long
 8 using namespace std;
 9 
10 const int MAXN = 2e5+10;
11 
12 struct EDGE
13 {
14     int v, nxt;
15 }edge[MAXN<<1];
16 int head[MAXN];
17 LL sum[MAXN], sumk[MAXN];
18 
19 int cost[MAXN], dep[MAXN];
20 int N, cnt;
21 LL ans, res;
22 
23 void add(int from, int to)
24 {
25     edge[cnt].v = to;
26     edge[cnt].nxt = head[from];
27     head[from] = cnt++;
28 }
29 void init()
30 {
31     memset(head, -1, sizeof(head));
32     cnt = 0;
33     ans = 0;
34 }
35 
36 void dfs1(int now, int dh, int fa)
37 {
38     //puts("zjy");ans = max(res, ans);
39     int to;
40     sum[now] = cost[now];
41     res += 1LL*cost[now]*dh;
42 //    dep[now] = dh;
43 //    f[now] = fa;
44     //printf("now: %d
", now);
45     for(int i = head[now]; i != -1; i = edge[i].nxt){
46         to = edge[i].v;
47         if(to != fa){
48             dfs1(to, dh+1, now);
49             sum[now]+=sum[to];
50         }
51     }
52 }
53 
54 void dfs2(int now, int fa)
55 {
56     ans = max(res, ans);
57     int to;
58     LL a, b, c;
59     for(int i = head[now]; i != -1; i = edge[i].nxt){
60         to = edge[i].v;
61         if(to == fa) continue;
62         a = sum[now], b = sum[to], c = res;
63         res-=sum[to];               //当前子树的节点距离-1
64         res+=sum[now]-sum[to];      //当前非子树节点距离+1
65         sum[now]-=sum[to];
66         sum[to] = a;
67         dfs2(to, now);
68         sum[now] = a;   //还原
69         sum[to] = b;
70         res = c;
71     }
72 }
73 
74 int main()
75 {
76     int i, j;
77     init();
78     scanf("%I64d", &N);
79     FOR(i, N) scanf("%I64d", &cost[i]);
80     int u, v;
81     for(i = 1; i < N; i++){
82         scanf("%d %d", &u, &v);
83         add(u, v);
84         add(v, u);
85     }
86     //puts("zjy");
87     dfs1(1, 0, 1);      //第一次递归求初始值
88     dfs2(1, 1);
89     printf("%I64d
", ans);
90     return 0;
91 }

二、树形dp

同样需要一次DFS 预处理出 s[ u ] 以 u 为根的子树的贡献总和(包括 u 结点本身);

状态:dp[ u ]  以 u 为根时,整棵树的贡献和

状态转移:dp[u] = dp[fa] + sum - 2*s[u]; ( sum 为所有结点的权值总和)

假设 fa = 1,u = 5;

dp[ 5 ] = dp[ 1 ] + 红色 - 蓝色 - cost[ u ];

dp[ 5 ] = dp[ 1 ] + ( sum - s[ 5 ]) - s[ 5 ];

dp[ 5 ] = dp[ 1 ]  + sum - 2*s[ 5 ];

AC code:

 1 #include <cstdio>
 2 #include <iostream>
 3 #include <cstring>
 4 #define FOR(x, maxx) for(x = 1; x <= maxx; x++)
 5 #define ZERO(aa, x) memset(aa, x, sizeof(aa))
 6 #define INF 0x3f3f3f3f
 7 #define LL long long
 8 using namespace std;
 9 
10 const int MAXN = 2e5+10;
11 
12 struct EDGE
13 {
14     int v, nxt;
15 }edge[MAXN<<1];
16 int head[MAXN], cnt;;
17 LL sum[MAXN], dp[MAXN];
18 LL cost[MAXN];
19 LL ans, res;
20 LL SSum;
21 int N;
22 
23 void add(int from, int to)
24 {
25     edge[cnt].v = to;
26     edge[cnt].nxt = head[from];
27     head[from] = cnt++;
28 }
29 void init()
30 {
31     memset(head, -1, sizeof(head));
32     memset(dp, 0, sizeof(dp));
33     SSum = 0LL;
34     cnt = 0;
35     ans = 0;
36 }
37 
38 void dfs(int now, int fa)
39 {
40     int to;
41     sum[now] = cost[now];
42     for(int i = head[now]; i != -1; i = edge[i].nxt){
43         to = edge[i].v;
44         if(to == fa) continue;
45         dfs(to, now);
46         sum[now]+=sum[to];
47         dp[now] = dp[now] + dp[to] + sum[to];
48     }
49 }
50 
51 void solve(int now, int fa)
52 {
53     int to;
54     if(fa) dp[now] = dp[fa]+SSum-2*sum[now];
55     for(int i = head[now]; i != -1; i = edge[i].nxt){
56         to = edge[i].v;
57         if(to == fa) continue;
58         solve(to, now);
59     }
60     ans = max(ans, dp[now]);
61 }
62 
63 int main()
64 {
65     init();
66     scanf("%d", &N);
67     for(int i = 1; i <= N; i++){
68         scanf("%I64d", &cost[i]);
69         SSum+=cost[i];
70     }
71     int u, v;
72     for(int i = 1; i < N; i++){
73         scanf("%d %d", &u, &v);
74         add(u, v);
75         add(v, u);
76     }
77     //puts("zjy");
78     dfs(1, 0);      //第一次递归求初始值
79     solve(1, 0);
80     printf("%I64d
", ans);
81     return 0;
82 }
原文地址:https://www.cnblogs.com/ymzjj/p/10167734.html